=== core/utilities/CMakeLists.txt ===
#
# Copyright (c) 2010-2022 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

add_subdirectory(advancedrename)
add_subdirectory(queuemanager)
add_subdirectory(imageeditor)
add_subdirectory(lighttable)
add_subdirectory(firstrun)
add_subdirectory(import)
add_subdirectory(setup)
add_subdirectory(fuzzysearch)
add_subdirectory(maintenance)
add_subdirectory(searchwindow)
add_subdirectory(extrasupport)
add_subdirectory(facemanagement)
add_subdirectory(focuspointmanagement)

if(${Marble_FOUND})
    add_subdirectory(geolocation)
endif()
