=== debian/changelog ===
digikam (4:7.9.0-1) unstable; urgency=medium

  [ Steve Robbins ]
  * [3e085d9] New upstream version 7.9.0.  Closes: #1024960.
  * [9da7704] re-base patches
  * [3d7c5fe] Update uploaders.
  * [376676f] update overrides

 -- Steve M. Robbins <smr@debian.org>  Thu, 08 Dec 2022 22:40:39 -0600
