=== debian/watch ===
version=4

opts=pgpmode=auto,uversionmangle=s/-/~/  \
 https://download.kde.org/stable/digikam/@ANY_VERSION@/digikam-@ANY_VERSION@.tar.xz debian
